/* OS2POINT Installation / Extraction
 * 30.12.95 Thomas Waldmann
 */

version     = '20'
opprefix    = 'op'||version
header      = opprefix'inst.dat'
headerlen   = 49845
opcomppattc = opprefix||'????.opc'
opcomppattu = opprefix||'????.opu'
opcomppattf = opprefix||'????.opf'

call RxFuncAdd 'SysLoadFuncs', 'RexxUtil', 'SysLoadFuncs'
call SysLoadFuncs

call SysCls

say 'OS2POINT Installation'
say '====================='
say ''
say 'English:'
say '1. Create a new directory on your hard disk (min. 20 MB free), e.g.'
say '   X:\POINT\ - this is the installation directory for OS2POINT.'
say '2. Copy *ALL* files of the point package (OP??*.* etc.) to this directory.'
say '3. Change into the installation directory and start OP20INST.CMD.'
say ''
say 'Deutsch:'
say '1. Neues Verzeichnis auf der Platte (mind. 20 MB frei) erstellen, z.B.'
say '   X:\POINT\ - dies ist dann das Installationsverzeichnis fuer OS2POINT.'
say '2. Alle Files des Pointpaketes (OP??*.* etc.) dort hineinkopieren.'
say '3. Vom Installationsverzeichnis aus OP20INST.CMD starten.'
say ''
say '[0] I have not done this - abort! / Ich habe das noch nicht gemacht, abbrechen!'
say '[1] All OK, continue! / Alles OK so, weitermachen!'
say ''

pull answer
if answer==0 then exit

say ''

call ExtrFilesC opcomppattc
call ExtrFilesU opcomppattu
call ExtrFilesU opcomppattf

'@move op20*.op? request\os2point >NUL'
'@call op_instl'
'@move op20inst.dat request\os2point'
'@move op20inst.cmd request\os2point'
exit

ExtrFilesC:
  parse arg filespec
  call SysFileTree filespec, 'file', 'FO'
  if file.0<1 then return
  do i=1 to file.0
    call ExtractC file.i
  end
  return

ExtrFilesU:
  parse arg filespec
  call SysFileTree filespec, 'file', 'FO'
  if file.0<1 then return
  do i=1 to file.0
    call ExtractU file.i
  end
  return

ExtractC:
  parse arg fname
  namein  = header
  nameout = '$$TEMP$$.EXE'
  data = charin(namein, 1, headerlen)
  rc = stream(namein,'C','close')
  rc = charout(nameout, data)
  data = ''
  namein  = fname
  size = stream(namein,'C','query size')
  desc80b = charin(namein, 1, 80)
  say desc80b
  data = charin(namein, 81, size-80)
  data = translate(data, xrange('99'x,'98'x), xrange('00'x,'FF'x))
  rc = stream(namein,'C','close')
  rc = charout(nameout, data)
  rc = stream(nameout,'C','close')
  data = ''
  '@$$TEMP$$.EXE >NUL'
  if rc>0 then
    do
      say 'rc = 'rc
      say fname' is defective! -- 'fname' ist defekt!'
      exit
    end
  '@del $$TEMP$$.EXE >NUL'
  return

ExtractU:
  parse arg fname zipopt
  '@bin\unzip -o 'fname' 'zipopt' >NUL'
  if rc>0 then
    do
      say 'rc = 'rc
      say fname' is defective! -- 'fname' ist defekt!'
      exit
    end
  return
